#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 30000;

int deg[MAXN + 5], parent[MAXN + 5], sz[MAXN + 5];
bool odd[MAXN + 5];

int find_set(int u)
{
    if (u == parent[u]) return u;
    else return parent[u] = find_set(parent[u]);
}

void unite(int a, int b)
{
    a = find_set(a);
    b = find_set(b);
    if (sz[b] > sz[a]) swap(a, b);
    parent[b] = a;
    if (sz[a] == sz[b]) sz[a]++;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        parent[i] = i;
        sz[i] = 0;
    }

    for (int i = 0; i < m; ++ i)
    {
        int u, v;
        cin >> u >> v;
        deg[u]++;
        deg[v]++;
        unite(u, v);
    }

    long long ans = 0;
    vector<int> v;
    for (int i = 1; i <= n; ++ i)
    {
        if (deg[i] % 2 == 1) ans++;
        parent[i] = find_set(i);
        v.push_back(parent[i]);
    }

    ans /= 2;

    sort(v.begin(), v.end());

    int p = -1, cnt = 0;
    for (int i = 0; i < n; ++ i)
    {
        if (v[i] != p)
        {
            cnt++;
            p = v[i];
        }
    }

    ans += cnt;
    int cntodd = 0;
    for (int i = 1; i <= n; ++ i)
    {
        if (deg[i] % 2 == 1)
        {
            if (!odd[parent[i]])
            {
                odd[parent[i]] = true;
                cntodd++;
            }
        }
    }

    if (cntodd) ans -= cntodd;
    else if (cnt == 1) ans--;

    cout << ans << endl;

    return 0;
}
