#include<iostream>
#include<queue>
#include<utility>

#define endl '\n'

using namespace std;

const int MAXN=2e3+3,LIMIT=1e3;
int dist[MAXN][MAXN];
pair<int,int> dirs[4]={{0,-1},{0,1},{-1,0},{1,0}};

void add_politican(int x, int y, int s, int& for_gov, int& against_gov){
    if(dist[x][y]!=-2 and dist[x][y]<=s){
        if(dist[x][y] & 1){
            ++against_gov;
        }else{
            ++for_gov;
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n,s;
    cin>>n>>s;
    int LIMIT=1e3;
    for(int i=0;i<n;++i){
        int x,y;
        cin>>x>>y;
        x+=LIMIT;
        y+=LIMIT;
        dist[x][y]=-2;
    }

    for(int i=0;i<MAXN;++i){
        for(int i2=0;i2<MAXN;++i2){
            if(dist[i][i2]==0){
                dist[i][i2]=-1;
            }
        }
    }

    queue<pair<int,int>> bfs;
    bfs.push({LIMIT,LIMIT});
    dist[LIMIT][LIMIT]=0;
    while(!bfs.empty()){
        pair<int,int> curr=bfs.front();
        bfs.pop();
        for(int i=0;i<4;++i){
            int newx=curr.first+dirs[i].first;
            int newy=curr.second+dirs[i].second;
            if(newx>=0 and newy>=0 and newx<MAXN and newy<MAXN){
                if(dist[newx][newy]==-1){
                    dist[newx][newy]=dist[curr.first][curr.second]+1;
                    bfs.push({newx,newy});
                }
            }
        }
    }

    int for_gov=0,against_gov=0;
    for(int steps=0;steps<=s;++steps){
        for(int x=0;x<=steps;++x){
            int y=steps-x;
            add_politican(LIMIT+x,LIMIT+y,s,for_gov,against_gov);
            if(x!=0){
                add_politican(LIMIT-x,LIMIT+y,s,for_gov,against_gov);
            }
            if(y!=0){
                add_politican(LIMIT+x,LIMIT-y,s,for_gov,against_gov);
            }
            if(x!=0 and y!=0){
                add_politican(LIMIT-x,LIMIT-y,s,for_gov,against_gov);
            }
        }
    }
    cout<<for_gov<<" "<<against_gov<<endl;
return 0;
}
