#include<iostream>
#include<queue>
#include<utility>
#include<map>

#define endl '\n'

using namespace std;

const int MAXN=2e3+3,LIMIT=1e3;
pair<int,int> dirs[4]={{0,-1},{0,1},{-1,0},{1,0}};
map<pair<int,int>,int> dist;

void set_status(int x, int y, pair<int,int>& maxc, pair<int,int>& minc){
    if(dist[{x,y}]!=-2){
        dist[{x,y}]=-1;
    }
    if(make_pair(x,y)>maxc){
        maxc={x,y};
    }
    if(make_pair(x,y)<minc){
        minc={x,y};
    }
}

void add_politican(int x, int y, int s, int& for_gov, int& against_gov){
    if(dist[{x,y}]!=-2 and dist[{x,y}]<=s){
        if(dist[{x,y}] & 1){
            ++against_gov;
        }else{
            ++for_gov;
        }
    }
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n,s;
    cin>>n>>s;
    int LIMIT=1e3;
    for(int i=0;i<n;++i){
        int x,y;
        cin>>x>>y;
        x+=LIMIT;
        y+=LIMIT;
        dist[{x,y}]=-2;
    }

    pair<int,int> maxc={-1,-1},minc={MAXN,MAXN};
    for(int steps=0;steps<=5*s;++steps){
        for(int x=0;x<=steps;++x){
            int y=steps-x;
            set_status(LIMIT+x,LIMIT+y,maxc,minc);
            if(x!=0){
                set_status(LIMIT-x,LIMIT+y,maxc,minc);
            }
            if(y!=0){
                set_status(LIMIT+x,LIMIT-y,maxc,minc);
            }
            if(x!=0 and y!=0){
                set_status(LIMIT-x,LIMIT-y,maxc,minc);
            }
        }
    }

    queue<pair<int,int>> bfs;
    bfs.push({LIMIT,LIMIT});
    dist[{LIMIT,LIMIT}]=0;
    while(!bfs.empty()){
        pair<int,int> curr=bfs.front();
        bfs.pop();
        for(int i=0;i<4;++i){
            int newx=curr.first+dirs[i].first;
            int newy=curr.second+dirs[i].second;
            if(minc<=make_pair(newx,newy) and make_pair(newx,newy)<=maxc){
                if(dist[{newx,newy}]==-1){
                    dist[{newx,newy}]=dist[{curr.first,curr.second}]+1;
                    bfs.push({newx,newy});
                }
            }
        }
    }

    int for_gov=0,against_gov=0;
    for(int steps=0;steps<=10*s;++steps){
        for(int x=0;x<=steps;++x){
            int y=steps-x;
            add_politican(LIMIT+x,LIMIT+y,s,for_gov,against_gov);
            if(x!=0){
                add_politican(LIMIT-x,LIMIT+y,s,for_gov,against_gov);
            }
            if(y!=0){
                add_politican(LIMIT+x,LIMIT-y,s,for_gov,against_gov);
            }
            if(x!=0 and y!=0){
                add_politican(LIMIT-x,LIMIT-y,s,for_gov,against_gov);
            }
        }
    }
    cout<<for_gov<<" "<<against_gov<<endl;
return 0;
}
