#include <bits/stdc++.h>
#define DB(X) cerr << __LINE__ << " " << #X << ": " << X << endl
#define MIN(A, B) (((A) < (B)) ? (A) : (B))
#define MAX(A, B) (((A) > (B)) ? (A) : (B))
#define O 1010

using namespace std;

typedef int s32;
typedef unsigned int u32;
typedef long long s64;
typedef unsigned long long u64;

u64 n, s;
bool used[2 * O][2 * O];
s64 path[2 * O][2 * O];
u64 lft = O - 1, up = O - 1, rgt = O + 1, down = O + 1;
u64 gerb = 0, bsp = 0;

struct QE{
    s64 x;
    s64 y;
    u64 p;
};

void
bfs()
{
    queue<QE> bfsq;
    bfsq.push({O, O, 0});
    while (!bfsq.empty()) {
        QE c = bfsq.front();
        bfsq.pop();
        if (used[c.x][c.y]) continue;
        used[c.x][c.y] = true;
        if(c.x < lft || c.x > rgt || c.y < up || c.y > down) continue;
        path[c.x][c.y] = c.p;
        if (c.p <= s)
            if (c.p % 2 == 0) gerb++;
            else bsp++;
        bfsq.push({c.x + 1, c.y, c.p + 1});
        bfsq.push({c.x - 1, c.y, c.p + 1});
        bfsq.push({c.x, c.y + 1, c.p + 1});
        bfsq.push({c.x, c.y - 1, c.p + 1});
    }
}

void
calc_edge(u64 v)
{
        if (v >= s || v == 0) return;

        int local = s - v;
        int lgerb = local / 2, lbsp = local - (local/2);
        if (v % 2 == 0) {
            gerb += lgerb;
            bsp += lbsp;
        } else {
            gerb += lbsp;
            bsp += lgerb;
        }
}

void
calc_edges()
{
    for(int i = lft + 1; i < rgt; i++){
        calc_edge(path[i][up]);
        calc_edge(path[i][down]);
    }
    for(int i = up + 1; i < down; i++){
        calc_edge(path[lft][i]);
        calc_edge(path[rgt][i]);
    }
}

u64 sum0(u64 n){
    return (n * (n +1)) / 2;
}

void
calc_corner(u64 v)
{
    if (v >= s || v == 0) return;
    int local = s - v;

    int lgerb = local / 2, lbsp = local - (local/2);
    lgerb = 2 * sum0(lgerb);
    lbsp = 2 * sum0(lbsp);
    if (v % 2 == 0) {
        gerb += local / 2;
        gerb += lgerb;
        bsp += lbsp;
    } else {
        bsp += local/2;
        gerb += lbsp;
        bsp += lgerb;
    }
}

void
calc_corners()
{
    calc_corner(path[rgt][up]);
    calc_corner(path[rgt][down]);
    calc_corner(path[lft][up]);
    calc_corner(path[lft][down]);
}

int
main()
{
    scanf("%llu%llu", &n, &s);
    for (int i = 0; i < n; i++) {
        s64 x, y;
        scanf("%lld%lld", &x, &y);
        x += O;
        y += O;
        used[x][y] = true;
        lft = MIN(x, lft);
        rgt = MAX(x, rgt);
        up = MIN(y, up);
        down = MAX(y, down);
    }
    lft--;
    rgt++;
    up--;
    down++;
    bfs();
    calc_edges();
    calc_corners();
    /*for(int i = up; i <= down; i++) {
        for(int j = lft; j <= rgt; j++){
            printf("%d ", path[j][i]);
        }
        printf("\n");
    }*/
    printf("%lld %lld\n", gerb, bsp);
}

